<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderAnalogPushes.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderAnalogPushes_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderAnalogPushes.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Composite push button array on analog pin with debounce.&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERANALOGPUSHES</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classButtonsCommanderAnalogPushes.html#a838603d13e894d923700ec9ad9958cd7">   11</a></span>&#160;<a class="code" href="classButtonsCommanderAnalogPushes.html#a838603d13e894d923700ec9ad9958cd7">ButtonsCommanderAnalogPushes::ButtonsCommanderAnalogPushes</a>() : <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>(<a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    this-&gt;analogPin = 0;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    this-&gt;lastButtonState = LOW;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    this-&gt;lastDebounceTime = 0;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    this-&gt;debounceDelay = 50;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    this-&gt;size = 0;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;}</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="classButtonsCommanderAnalogPushes.html#afdee2008ec1f6f3f276bfa6193bfa60c">   22</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderAnalogPushes.html#afdee2008ec1f6f3f276bfa6193bfa60c">ButtonsCommanderAnalogPushes::begin</a>(<span class="keywordtype">int</span> inButtonPin, uint8_t inNumberOfItems, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *inpIds, <span class="keywordtype">int</span> *inpButtonValues, <span class="keywordtype">int</span> inTolerancy)</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{   </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    this-&gt;size = inNumberOfItems;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    this-&gt;pButtons = <span class="keyword">new</span> <a class="code" href="classButtonsCommanderAnalogPushesItem.html">ButtonsCommanderAnalogPushesItem</a>[this-&gt;size];</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    this-&gt;analogPin = inButtonPin;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    this-&gt;readingTolerancy = inTolerancy;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;size; i++)</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keywordflow">if</span> (inpButtonValues[i] &lt; 0 || inpButtonValues[i] &gt; 1023)</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            Serial.print(F(<span class="stringliteral">&quot;Analog push buttons. Invalid value &quot;</span>));</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            Serial.print(inpButtonValues[i]);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            Serial.print(F(<span class="stringliteral">&quot; for button &quot;</span>));</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            Serial.print(i);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;. Value must betwwen 0 and 1023 !&quot;</span>));</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        }</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        this-&gt;pButtons[i].<a class="code" href="classButtonsCommanderAnalogPushesItem.html#a8c814177a5d01a21d6aef4877858917b">begin</a>(inpIds[i], inpButtonValues[i], inTolerancy);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    }</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    pinMode(this-&gt;analogPin, INPUT);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classButtonsCommanderAnalogPushes.html#ae976e740dfe282cf22e107cfa6b13dc3">   48</a></span>&#160;<a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>* <a class="code" href="classButtonsCommanderAnalogPushes.html#ae976e740dfe282cf22e107cfa6b13dc3">ButtonsCommanderAnalogPushes::GetFromId</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;{</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;size; i++)</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">if</span> (this-&gt;pButtons[i].<a class="code" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a>() == inId)</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="keywordflow">return</span> &amp;(this-&gt;pButtons[i]);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;}            </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classButtonsCommanderAnalogPushes.html#ab72557e2f070f17498f5e43f82ec52f3">   57</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderAnalogPushes.html#ab72557e2f070f17498f5e43f82ec52f3">ButtonsCommanderAnalogPushes::loop</a>()</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;{</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> foundID = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">if</span> (this-&gt;analogPin == 0)</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">return</span> foundID;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="comment">// read the state of the switch into a local variable:</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">int</span> reading = analogRead(this-&gt;analogPin);</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// check to see if you just pressed the button </span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="comment">// (i.e. the input went from LOW to HIGH),  and you&#39;ve waited </span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="comment">// long enough since the last press to ignore any noise:  </span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="comment">// If the button changed, due to noise or pressing:</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordflow">if</span> (reading &lt; this-&gt;lastButtonState - this-&gt;readingTolerancy || reading &gt; this-&gt;lastButtonState + this-&gt;readingTolerancy)</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    {</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="comment">// reset the debouncing timer</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        this-&gt;lastDebounceTime = millis();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordflow">if</span> (this-&gt;lastDebounceTime &gt; 0 &amp;&amp; (millis() - this-&gt;lastDebounceTime) &gt; this-&gt;debounceDelay)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="comment">// whatever the reading is at, it&#39;s been there for longer</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="comment">// than the debounce delay, so take it as the actual current state:</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="comment">// if the button state has changed:</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordflow">if</span> (reading &lt; this-&gt;lastButtonState - this-&gt;readingTolerancy || reading &gt; this-&gt;lastButtonState + this-&gt;readingTolerancy)</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        {</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            this-&gt;lastButtonState = reading;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;size; i++)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                <span class="keywordflow">if</span> (this-&gt;pButtons[i].IsPushed(reading))</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                {</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                    foundID = this-&gt;pButtons[i].<a class="code" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a>();</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                    <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(foundID, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a>, 0);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                    Serial.print(F(<span class="stringliteral">&quot;Analog push button &quot;</span>));</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                    Serial.print(i);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;                    Serial.println(F(<span class="stringliteral">&quot; pressed&quot;</span>));</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                }</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        this-&gt;lastDebounceTime = 0;    </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    }</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment">// save the reading.  Next time through the loop,</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="comment">// it&#39;ll be the lastButtonState:</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    lastButtonState = reading;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">return</span> foundID;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;}</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classButtonsCommanderAnalogPushes.html#aed6eacfc1656e7aacd24cf3ab6565ea1">  109</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderAnalogPushes.html#aed6eacfc1656e7aacd24cf3ab6565ea1">ButtonsCommanderAnalogPushes::EndLoop</a>()</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;{</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    this-&gt;lastButtonPressed = -1;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;}</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keywordtype">void</span> ButtonsCommanderAnalogPushes::printCommander()</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;{</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;    AnalogPushes - Pin :&quot;</span>));</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    Serial.println(this-&gt;analogPin);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Reading Accuracy: &quot;</span>));</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    Serial.println(this-&gt;readingTolerancy);</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;size; i++)</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    {</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;        &quot;</span>));</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        this-&gt;<a class="code" href="classButtonsCommanderAnalogPushes.html#a6f796b9880e1d9b7a41a26fdf972a3c0">GetItem</a>(i)-&gt;printCommander();</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    }</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;}</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classButtonsCommanderAnalogPushes_html_a6f796b9880e1d9b7a41a26fdf972a3c0"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#a6f796b9880e1d9b7a41a26fdf972a3c0">ButtonsCommanderAnalogPushes::GetItem</a></div><div class="ttdeci">ButtonsCommanderAnalogPushesItem * GetItem(uint8_t inNumber)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8hpp_source.html#l00082">ButtonsCommanderAnalogPushes.hpp:82</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushes_html_aed6eacfc1656e7aacd24cf3ab6565ea1"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#aed6eacfc1656e7aacd24cf3ab6565ea1">ButtonsCommanderAnalogPushes::EndLoop</a></div><div class="ttdeci">void EndLoop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00109">ButtonsCommanderAnalogPushes.cpp:109</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00032">Events.h:32</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_acbdd1d63fed7736c7358105428fbfd9c"><div class="ttname"><a href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">ButtonsCommanderButton::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00030">ButtonsCommanderButton.hpp:30</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushes_html_ae976e740dfe282cf22e107cfa6b13dc3"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#ae976e740dfe282cf22e107cfa6b13dc3">ButtonsCommanderAnalogPushes::GetFromId</a></div><div class="ttdeci">ButtonsCommanderButton * GetFromId(unsigned long inId)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00048">ButtonsCommanderAnalogPushes.cpp:48</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushesItem_html_a8c814177a5d01a21d6aef4877858917b"><div class="ttname"><a href="classButtonsCommanderAnalogPushesItem.html#a8c814177a5d01a21d6aef4877858917b">ButtonsCommanderAnalogPushesItem::begin</a></div><div class="ttdeci">void begin(unsigned long inId, int inAnalogValue, int inTolerancy)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushesItem_8hpp_source.html#l00029">ButtonsCommanderAnalogPushesItem.hpp:29</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushesItem_html"><div class="ttname"><a href="classButtonsCommanderAnalogPushesItem.html">ButtonsCommanderAnalogPushesItem</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushesItem_8hpp_source.html#l00012">ButtonsCommanderAnalogPushesItem.hpp:12</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushes_html_afdee2008ec1f6f3f276bfa6193bfa60c"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#afdee2008ec1f6f3f276bfa6193bfa60c">ButtonsCommanderAnalogPushes::begin</a></div><div class="ttdeci">void begin(int inButtonPin, uint8_t inNumber, unsigned long *inpIds, int *inpButtonValues, int inTolerancy = 20)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00022">ButtonsCommanderAnalogPushes.cpp:22</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushes_html_ab72557e2f070f17498f5e43f82ec52f3"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#ab72557e2f070f17498f5e43f82ec52f3">ButtonsCommanderAnalogPushes::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00057">ButtonsCommanderAnalogPushes.cpp:57</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classButtonsCommanderAnalogPushes_html_a838603d13e894d923700ec9ad9958cd7"><div class="ttname"><a href="classButtonsCommanderAnalogPushes.html#a838603d13e894d923700ec9ad9958cd7">ButtonsCommanderAnalogPushes::ButtonsCommanderAnalogPushes</a></div><div class="ttdeci">ButtonsCommanderAnalogPushes()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00011">ButtonsCommanderAnalogPushes.cpp:11</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderAnalogPushes.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
